Index: /trunk/src/sys/arch/mips/mips/pmap.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/pmap.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/pmap.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmap.c,v 1.179.16.24 2010/05/04 17:15:36 matt Exp $	*/
+/*	pmap.c,v 1.179.16.28 2011/04/29 08:26:29 matt Exp	*/
 
 /*-
@@ -68,5 +68,5 @@
 #include <sys/cdefs.h>
 
-__KERNEL_RCSID(0, "$NetBSD: pmap.c,v 1.179.16.24 2010/05/04 17:15:36 matt Exp $");
+__KERNEL_RCSID(0, "pmap.c,v 1.179.16.28 2011/04/29 08:26:29 matt Exp");
 
 /*
@@ -124,6 +124,6 @@
 #include <sys/systm.h>
 #include <sys/proc.h>
+#include <sys/cpu.h>
 #include <sys/malloc.h>
-#include <sys/user.h>
 #include <sys/buf.h>
 #include <sys/pool.h>
@@ -337,7 +337,7 @@
 
 static inline bool
-pmap_clear_page_attributes(struct vm_page *pg, u_int clear_attributes)
-{
-	volatile u_int * const attrp = &pg->mdpage.pvh_attrs;
+pmap_clear_mdpage_attributes(struct vm_page_md *md, u_int clear_attributes)
+{
+	volatile u_int * const attrp = &md->pvh_attrs;
 #ifdef MULTIPROCESSOR
 	for (;;) {
@@ -359,10 +359,10 @@
 
 static inline void
-pmap_set_page_attributes(struct vm_page *pg, u_int set_attributes)
+pmap_set_mdpage_attributes(struct vm_page_md *md, u_int set_attributes)
 {
 #ifdef MULTIPROCESSOR
-	atomic_or_uint(&pg->mdpage.pvh_attrs, set_attributes);
+	atomic_or_uint(&md->pvh_attrs, set_attributes);
 #else
-	pg->mdpage.pvh_attrs |= set_attributes;
+	md->pvh_attrs |= set_attributes;
 #endif
 }
@@ -371,8 +371,9 @@
 pmap_page_syncicache(struct vm_page *pg)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 #ifdef MULTIPROCESSOR
-	pv_entry_t pv = &pg->mdpage.pvh_first;
+	pv_entry_t pv = &md->pvh_first;
 	uint32_t onproc = 0;
-	(void)VM_PAGE_PVLIST_LOCK(pg, false);
+	(void)PG_MD_PVLIST_LOCK(md, false);
 	if (pv->pv_pmap != NULL) {
 		for (; pv != NULL; pv = pv->pv_next) {
@@ -382,13 +383,13 @@
 		}
 	}
-	VM_PAGE_PVLIST_UNLOCK(pg);
+	PG_MD_PVLIST_UNLOCK(md);
 	kpreempt_disable();
-	pmap_tlb_syncicache(pg->mdpage.pvh_first.pv_va, onproc);
+	pmap_tlb_syncicache(md->pvh_first.pv_va, onproc);
 	kpreempt_enable();
 #else
 	if (MIPS_HAS_R4K_MMU) {
-		if (PG_MD_CACHED_P(pg)) {
+		if (PG_MD_CACHED_P(md)) {
 			mips_icache_sync_range_index(
-			    pg->mdpage.pvh_first.pv_va, PAGE_SIZE);
+			    md->pvh_first.pv_va, PAGE_SIZE);
 		}
 	} else {
@@ -403,5 +404,6 @@
 {
 	const paddr_t pa = VM_PAGE_TO_PHYS(pg);
-	pv_entry_t pv = &pg->mdpage.pvh_first;
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+	pv_entry_t pv = &md->pvh_first;
 
 #ifdef _LP64
@@ -431,11 +433,11 @@
 		 * page from the cache so we will copy the correct contents.
 		 */
-		(void)VM_PAGE_PVLIST_LOCK(pg, false);
-		if (PG_MD_CACHED_P(pg)
+		(void)PG_MD_PVLIST_LOCK(md, false);
+		if (PG_MD_CACHED_P(md)
 		    && mips_cache_badalias(pv->pv_va, va))
 			mips_dcache_wbinv_range_index(pv->pv_va, PAGE_SIZE);
 		if (pv->pv_pmap == NULL)
 			pv->pv_va = va;
-		VM_PAGE_PVLIST_UNLOCK(pg);
+		PG_MD_PVLIST_UNLOCK(md);
 	}
 
@@ -447,9 +449,10 @@
 	pt_entry_t old_pt_entry)
 {
-	pv_entry_t pv = &pg->mdpage.pvh_first;
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+	pv_entry_t pv = &md->pvh_first;
 	
-	(void)VM_PAGE_PVLIST_LOCK(pg, false);
+	(void)PG_MD_PVLIST_LOCK(md, false);
 	if (MIPS_CACHE_VIRTUAL_ALIAS
-	    && (PG_MD_UNCACHED_P(pg)
+	    && (PG_MD_UNCACHED_P(md)
 		|| (pv->pv_pmap != NULL
 		    && mips_cache_badalias(pv->pv_va, va)))) {
@@ -461,5 +464,5 @@
 		mips_dcache_wbinv_range(va, PAGE_SIZE);
 	}
-	VM_PAGE_PVLIST_UNLOCK(pg);
+	PG_MD_PVLIST_UNLOCK(md);
 #ifndef _LP64
 	/*
@@ -487,4 +490,6 @@
 	vsize_t bufsz;
 
+	pmap_page_colormask = (uvmexp.ncolors -1) << PAGE_SHIFT;
+
 	pmap_tlb_info_init(&pmap_tlb0_info);		/* init the lock */
 
@@ -518,6 +523,16 @@
 	Sysmapsize += poolpage.size;
 #endif
+#ifdef _LP64
+	/*
+	 * If we are using tmpfs, then we might want to use a great deal of
+	 * our memory with it.  Make sure we have enough VM to do that.
+	 */
+	Sysmapsize += physmem;
+#else
 	/* XXX: else runs out of space on 256MB sbmips!! */
 	Sysmapsize += 20000;
+#endif
+	/* Rounup to a even number of pte page tables */
+	Sysmapsize = (Sysmapsize + NPTEPG - 1) & -NPTEPG;
 
 	/*
@@ -527,7 +542,8 @@
 	 * can be called.
 	 */
-	mips_avail_start = vm_physmem[0].start << PGSHIFT;
-	mips_avail_end = vm_physmem[vm_nphysseg - 1].end << PGSHIFT;
-	mips_virtual_end = VM_MIN_KERNEL_ADDRESS + Sysmapsize * NBPG;
+	mips_avail_start = ptoa(VM_PHYSMEM_PTR(0)->start);
+	mips_avail_end = ptoa(VM_PHYSMEM_PTR(vm_nphysseg - 1)->end);
+	mips_virtual_end = VM_MIN_KERNEL_ADDRESS + (vaddr_t)Sysmapsize * NBPG;
+
 #ifndef _LP64
 	if (mips_virtual_end > VM_MAX_KERNEL_ADDRESS) {
@@ -547,7 +563,7 @@
 
 #ifdef PMAP_POOLPAGE_DEBUG
-	mips_virtual_end -= poolpage.limit;
+	mips_virtual_end -= poolpage.size;
 	poolpage.base = mips_virtual_end;
-	poolpage.sysmap += Sysmap + atop(poolpage.size);
+	poolpage.sysmap = Sysmap + atop(poolpage.size);
 #endif
 	/*
@@ -615,40 +631,83 @@
 	paddr_t pa;
 	vaddr_t va;
+	struct vm_physseg *maybe_seg = NULL;
+	u_int maybe_bank = vm_nphysseg;
 
 	size = round_page(size);
 	npgs = atop(size);
 
+	aprint_debug("%s: need %u pages\n", __func__, npgs);
+
 	for (u_int bank = 0; bank < vm_nphysseg; bank++) {
+		struct vm_physseg * const seg = VM_PHYSMEM_PTR(bank);
 		if (uvm.page_init_done == true)
 			panic("pmap_steal_memory: called _after_ bootstrap");
 
-		if (vm_physmem[bank].avail_start != vm_physmem[bank].start ||
-		    vm_physmem[bank].avail_start >= vm_physmem[bank].avail_end)
+		aprint_debug("%s: seg %u: %#"PRIxPADDR" %#"PRIxPADDR" %#"PRIxPADDR" %#"PRIxPADDR"\n",
+		    __func__, bank,
+		    seg->avail_start, seg->start,
+		    seg->avail_end, seg->end);
+
+		if (seg->avail_start != seg->start
+		    || seg->avail_start >= seg->avail_end) {
+			aprint_debug("%s: seg %u: bad start\n", __func__, bank);
 			continue;
-
-		if ((vm_physmem[bank].avail_end - vm_physmem[bank].avail_start)
-		    < npgs)
+		}
+
+		if (seg->avail_end - seg->avail_start < npgs) {
+			aprint_debug("%s: seg %u: too small for %u pages\n",
+			    __func__, bank, npgs);
 			continue;
+		}
+
+#ifndef _LP64
+		if (seg->avail_start + npgs > MIPS_PHYS_MASK + 1) {
+			aprint_debug("%s: seg %u: not enough in KSEG0 for %u pages\n",
+			    __func__, bank, npgs);
+			continue;
+		}
+#endif
+
+		/*
+		 * Always try to allocate from the segment with the least
+		 * amount of space left.
+		 */
+#define VM_PHYSMEM_SPACE(s)	((s)->avail_end - (s)->avail_start)
+		if (maybe_seg == NULL 
+		    || VM_PHYSMEM_SPACE(seg) < VM_PHYSMEM_SPACE(maybe_seg)) {
+			maybe_seg = seg;
+			maybe_bank = bank;
+		}
+	}
+
+	if (maybe_seg) {
+		struct vm_physseg * const seg = maybe_seg;
+		u_int bank = maybe_bank;
 
 		/*
 		 * There are enough pages here; steal them!
 		 */
-		pa = ptoa(vm_physmem[bank].avail_start);
-		vm_physmem[bank].avail_start += npgs;
-		vm_physmem[bank].start += npgs;
+		pa = ptoa(seg->avail_start);
+		seg->avail_start += npgs;
+		seg->start += npgs;
 
 		/*
 		 * Have we used up this segment?
 		 */
-		if (vm_physmem[bank].avail_start == vm_physmem[bank].end) {
+		if (seg->avail_start == seg->end) {
 			if (vm_nphysseg == 1)
 				panic("pmap_steal_memory: out of memory!");
 
+			aprint_debug("%s: seg %u: %u pages stolen (removed)\n",
+			    __func__, bank, npgs);
 			/* Remove this segment from the list. */
 			vm_nphysseg--;
 			for (u_int x = bank; x < vm_nphysseg; x++) {
 				/* structure copy */
-				vm_physmem[x] = vm_physmem[x + 1];
+				VM_PHYSMEM_PTR_SWAP(x, x + 1);
 			}
+		} else {
+			aprint_debug("%s: seg %u: %u pages stolen (%#"PRIxPADDR" left)\n",
+			    __func__, bank, npgs, VM_PHYSMEM_SPACE(seg));
 		}
 
@@ -714,13 +773,15 @@
 	if (mips_avail_end > MIPS_KSEG1_START - MIPS_KSEG0_START) {
 		curcpu()->ci_pmap_dstbase = uvm_km_alloc(kernel_map,
-		    uvmexp.ncolors * PAGE_SIZE, 0, UVM_KMF_VAONLY);
+		    uvmexp.ncolors * PAGE_SIZE, 0,
+		    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY);
 		KASSERT(curcpu()->ci_pmap_dstbase);
 		curcpu()->ci_pmap_srcbase = uvm_km_alloc(kernel_map,
-		    uvmexp.ncolors * PAGE_SIZE, 0, UVM_KMF_VAONLY);
+		    uvmexp.ncolors * PAGE_SIZE, 0,
+		    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY);
 		KASSERT(curcpu()->ci_pmap_srcbase);
 	}
 #endif
 
-#ifdef MIPS3
+#if defined(MIPS3) && 0
 	if (MIPS_HAS_R4K_MMU) {
 		/*
@@ -729,9 +790,9 @@
 		 * on MIPS3 CPUs to avoid possible virtual cache aliases
 		 * and uncached mappings in pmap_enter_pv().
-		 * 
+		 *
 		 * Ideally, read only shared mapping won't cause aliases
 		 * so pmap_enter_pv() should handle any shared read only
 		 * mappings without uncached ops like ARM pmap.
-		 * 
+		 *
 		 * On the other hand, R4000 and R4400 have the virtual
 		 * coherency exceptions which will happen even on read only
@@ -772,5 +833,5 @@
 	pmap->pm_count = 1;
 
-	pmap_segtab_alloc(pmap);
+	pmap_segtab_init(pmap);
 
 	return pmap;
@@ -798,5 +859,5 @@
 	kpreempt_disable();
 	pmap_tlb_asid_release_all(pmap);
-	pmap_segtab_free(pmap);
+	pmap_segtab_destroy(pmap);
 
 	pool_put(&pmap_pmap_pool, pmap);
@@ -848,5 +909,11 @@
 
 	kpreempt_disable();
-	curcpu()->ci_pmap_segbase = (void *)(MIPS_KSEG2_START + 0x1eadbeef);
+	KASSERT(l == curlwp || l->l_cpu == curlwp->l_cpu);
+#ifdef _LP64
+	curcpu()->ci_pmap_segtab = (void *)(MIPS_KSEG2_START + 0x1eadbeef);
+	curcpu()->ci_pmap_seg0tab = NULL;
+#else
+	curcpu()->ci_pmap_seg0tab = (void *)(MIPS_KSEG2_START + 0x1eadbeef);
+#endif
 	pmap_tlb_asid_deactivate(l->l_proc->p_vmspace->vm_map.pmap);
 	kpreempt_enable();
@@ -979,4 +1046,9 @@
 	}
 #endif
+#ifdef PMAP_FAULTINFO
+	curpcb->pcb_faultinfo.pfi_faultaddr = 0;
+	curpcb->pcb_faultinfo.pfi_repeats = 0;
+	curpcb->pcb_faultinfo.pfi_faultpte = NULL;
+#endif
 	pmap_pte_process(pmap, sva, eva, pmap_pte_remove, 0);
 	kpreempt_enable();
@@ -991,4 +1063,5 @@
 pmap_page_protect(struct vm_page *pg, vm_prot_t prot)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 	pv_entry_t pv;
 	vaddr_t va;
@@ -1009,6 +1082,6 @@
 	case VM_PROT_READ:
 	case VM_PROT_READ|VM_PROT_EXECUTE:
-		(void)VM_PAGE_PVLIST_LOCK(pg, false);
-		pv = &pg->mdpage.pvh_first;
+		(void)PG_MD_PVLIST_LOCK(md, false);
+		pv = &md->pvh_first;
 		/*
 		 * Loop over all current mappings setting/clearing as apropos.
@@ -1017,12 +1090,12 @@
 			while (pv != NULL) {
 				const pmap_t pmap = pv->pv_pmap;
-				const uint16_t gen = VM_PAGE_PVLIST_GEN(pg);
+				const uint16_t gen = PG_MD_PVLIST_GEN(md);
 				va = pv->pv_va;
-				VM_PAGE_PVLIST_UNLOCK(pg);
+				PG_MD_PVLIST_UNLOCK(md);
 				pmap_protect(pmap, va, va + PAGE_SIZE, prot);
 				KASSERT(pv->pv_pmap == pmap);
 				pmap_update(pmap);
-				if (gen != VM_PAGE_PVLIST_LOCK(pg, false)) {
-					pv = &pg->mdpage.pvh_first;
+				if (gen != PG_MD_PVLIST_LOCK(md, false)) {
+					pv = &md->pvh_first;
 				} else {
 					pv = pv->pv_next;
@@ -1030,5 +1103,5 @@
 			}
 		}
-		VM_PAGE_PVLIST_UNLOCK(pg);
+		PG_MD_PVLIST_UNLOCK(md);
 		break;
 
@@ -1039,18 +1112,18 @@
 		 * won't try to sync the icache.
 		 */
-		if (pmap_clear_page_attributes(pg, PG_MD_EXECPAGE)) {
+		if (pmap_clear_mdpage_attributes(md, PG_MD_EXECPAGE)) {
 			PMAP_COUNT(exec_uncached_page_protect);
 		}
-		(void)VM_PAGE_PVLIST_LOCK(pg, false);
-		pv = &pg->mdpage.pvh_first;
+		(void)PG_MD_PVLIST_LOCK(md, false);
+		pv = &md->pvh_first;
 		while (pv->pv_pmap != NULL) {
 			const pmap_t pmap = pv->pv_pmap;
 			va = pv->pv_va;
-			VM_PAGE_PVLIST_UNLOCK(pg);
+			PG_MD_PVLIST_UNLOCK(md);
 			pmap_remove(pmap, va, va + PAGE_SIZE);
 			pmap_update(pmap);
-			(void)VM_PAGE_PVLIST_LOCK(pg, false);
-		}
-		VM_PAGE_PVLIST_UNLOCK(pg);
+			(void)PG_MD_PVLIST_LOCK(md, false);
+		}
+		PG_MD_PVLIST_UNLOCK(md);
 	}
 }
@@ -1073,11 +1146,12 @@
 		pg = PHYS_TO_VM_PAGE(mips_tlbpfn_to_paddr(pt_entry));
 		if (pg && (pt_entry & mips_pg_m_bit())) {
+			struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 			if (MIPS_HAS_R4K_MMU
 			    && MIPS_CACHE_VIRTUAL_ALIAS
-			    && PG_MD_CACHED_P(pg))
+			    && PG_MD_CACHED_P(md))
 				mips_dcache_wbinv_range_index(sva, PAGE_SIZE);
-			if (PG_MD_EXECPAGE_P(pg)) {
-				KASSERT(pg->mdpage.pvh_first.pv_pmap != NULL);
-				if (PG_MD_CACHED_P(pg)) {
+			if (PG_MD_EXECPAGE_P(md)) {
+				KASSERT(md->pvh_first.pv_pmap != NULL);
+				if (PG_MD_CACHED_P(md)) {
 					pmap_page_syncicache(pg);
 					PMAP_COUNT(exec_synced_protect);
@@ -1244,4 +1318,5 @@
 pmap_page_cache(struct vm_page *pg, bool cached)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 	const uint32_t newmode = cached ? MIPS3_PG_CACHED : MIPS3_PG_UNCACHED;
 
@@ -1251,16 +1326,16 @@
 		printf("pmap_page_uncache(%#"PRIxPADDR")\n", VM_PAGE_TO_PHYS(pg));
 #endif
-	
+
 	if (cached) {
-		pmap_clear_page_attributes(pg, PG_MD_UNCACHED);
+		pmap_clear_mdpage_attributes(md, PG_MD_UNCACHED);
 		PMAP_COUNT(page_cache_restorations);
 	} else {
-		pmap_set_page_attributes(pg, PG_MD_UNCACHED);
+		pmap_set_mdpage_attributes(md, PG_MD_UNCACHED);
 		PMAP_COUNT(page_cache_evictions);
 	}
 
-	KASSERT(VM_PAGE_PVLIST_LOCKED_P(pg));
+	KASSERT(PG_MD_PVLIST_LOCKED_P(md));
 	KASSERT(kpreempt_disabled());
-	for (pv_entry_t pv = &pg->mdpage.pvh_first;
+	for (pv_entry_t pv = &md->pvh_first;
 	     pv != NULL;
 	     pv = pv->pv_next) {
@@ -1322,7 +1397,10 @@
 	if (pmapdebug & (PDB_FOLLOW|PDB_ENTER))
 		printf("pmap_enter(%p, %#"PRIxVADDR", %#"PRIxPADDR", %x, %x)\n",
-		    pmap, va, pa, prot, wired);
+		    pmap, va, pa, prot, flags);
 #endif
 	const bool good_color = PMAP_PAGE_COLOROK_P(pa, va);
+	KASSERTMSG(good_color,
+	    ("%s(%p, %#"PRIxVADDR", %#"PRIxPADDR", %x, %x): color mismatch\n",
+	     __func__, pmap, va, pa, prot, flags));
 	if (pmap == pmap_kernel()) {
 		PMAP_COUNT(kernel_mappings);
@@ -1361,9 +1439,11 @@
 
 	if (pg) {
+		struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+
 		/* Set page referenced/modified status based on flags */
 		if (flags & VM_PROT_WRITE)
-			pmap_set_page_attributes(pg, PG_MD_MODIFIED|PG_MD_REFERENCED);
+			pmap_set_mdpage_attributes(md, PG_MD_MODIFIED|PG_MD_REFERENCED);
 		else if (flags & VM_PROT_ALL)
-			pmap_set_page_attributes(pg, PG_MD_REFERENCED);
+			pmap_set_mdpage_attributes(md, PG_MD_REFERENCED);
 		if (!(prot & VM_PROT_WRITE))
 			/*
@@ -1378,5 +1458,5 @@
 #if defined(_MIPS_PADDR_T_64BIT) || defined(_LP64)
 			if (cached == false) {
-				if (PG_MD_MODIFIED_P(pg)) {
+				if (PG_MD_MODIFIED_P(md)) {
 					npte = mips_pg_rwncpage_bit();
 				} else {
@@ -1386,5 +1466,5 @@
 			} else {
 #endif
-				if (PG_MD_MODIFIED_P(pg)) {
+				if (PG_MD_MODIFIED_P(md)) {
 					npte = mips_pg_rwpage_bit();
 				} else {
@@ -1429,9 +1509,10 @@
 	    && pg != NULL
 	    && prot == (VM_PROT_READ | VM_PROT_EXECUTE)) {
+		struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 		PMAP_COUNT(enter_exec_mapping);
-		if (!PG_MD_EXECPAGE_P(pg)) {
+		if (!PG_MD_EXECPAGE_P(md)) {
 			mips_icache_sync_range(MIPS_PHYS_TO_KSEG0(pa),
 			    PAGE_SIZE);
-			pmap_set_page_attributes(pg, PG_MD_EXECPAGE);
+			pmap_set_mdpage_attributes(md, PG_MD_EXECPAGE);
 			PMAP_COUNT(exec_syncicache_entry);
 		}
@@ -1523,11 +1604,26 @@
 	if (mips_pg_v(pte->pt_entry) &&
 	    mips_tlbpfn_to_paddr(pte->pt_entry) != pa) {
+#ifdef PMAP_FAULTINFO
+		struct pcb_faultinfo tmp_fi = curpcb->pcb_faultinfo;
+#endif
 		pmap_remove(pmap, va, va + NBPG);
+#ifdef PMAP_FAULTINFO
+		curpcb->pcb_faultinfo = tmp_fi;
+#endif
 		PMAP_COUNT(user_mappings_changed);
 	}
 
+	KASSERT(mips_pg_v(npte));
 	bool resident = mips_pg_v(pte->pt_entry);
 	if (!resident)
 		pmap->pm_stats.resident_count++;
+#ifdef PMAP_FAULTINFO
+	if (curpcb->pcb_faultinfo.pfi_faultpte == pte
+	    && curpcb->pcb_faultinfo.pfi_repeats > 1) {
+		printf("%s(%#"PRIxVADDR", %#"PRIxPADDR"): changing pte@%p from %#x to %#x\n",
+		    __func__, va, pa, pte, pte->pt_entry, npte);
+		cpu_Debugger();
+	}
+#endif
 	pte->pt_entry = npte;
 
@@ -1536,4 +1632,5 @@
 
 	if (pg != NULL && (prot == (VM_PROT_READ | VM_PROT_EXECUTE))) {
+		struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 #ifdef DEBUG
 		if (pmapdebug & PDB_ENTER)
@@ -1542,7 +1639,7 @@
 #endif
 		PMAP_COUNT(exec_mappings);
-		if (!PG_MD_EXECPAGE_P(pg) && PG_MD_CACHED_P(pg)) {
+		if (!PG_MD_EXECPAGE_P(md) && PG_MD_CACHED_P(md)) {
 			pmap_page_syncicache(pg);
-			pmap_set_page_attributes(pg, PG_MD_EXECPAGE);
+			pmap_set_mdpage_attributes(md, PG_MD_EXECPAGE);
 			PMAP_COUNT(exec_synced_mappings);
 		}
@@ -1564,6 +1661,10 @@
 #endif
 	PMAP_COUNT(kenter_pa);
-	if (!PMAP_PAGE_COLOROK_P(pa, va) && managed)
+	KASSERTMSG(!managed || PMAP_PAGE_COLOROK_P(pa, va),
+	    ("%s(%#"PRIxVADDR", %#"PRIxPADDR", %x): color mismatch\n",
+	     __func__, va, pa, prot));
+	if (!PMAP_PAGE_COLOROK_P(pa, va) && managed) {
 		PMAP_COUNT(kenter_pa_bad);
+	}
 
 	if (!managed)
@@ -1610,16 +1711,17 @@
 		PMAP_COUNT(kremove_pages);
 		if (MIPS_HAS_R4K_MMU && MIPS_CACHE_VIRTUAL_ALIAS) {
-			struct vm_page *pg =
+			struct vm_page * const pg =
 			    PHYS_TO_VM_PAGE(mips_tlbpfn_to_paddr(pt_entry));
 			if (pg != NULL) {
-				(void)VM_PAGE_PVLIST_LOCK(pg, false);
-				pv_entry_t pv = &pg->mdpage.pvh_first;
+				struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+				(void)PG_MD_PVLIST_LOCK(md, false);
+				pv_entry_t pv = &md->pvh_first;
 				if (pv->pv_pmap == NULL) {
-					pv->pv_va = va; 
-				} else if (PG_MD_CACHED_P(pg)
+					pv->pv_va = va;
+				} else if (PG_MD_CACHED_P(md)
 				    && mips_cache_badalias(pv->pv_va, va)) {
 					mips_dcache_wbinv_range(va, PAGE_SIZE);
 				}
-				VM_PAGE_PVLIST_UNLOCK(pg);
+				PG_MD_PVLIST_UNLOCK(md);
 			}
 		}
@@ -1641,7 +1743,18 @@
 	 * tlb_invalidate_addrs().
 	 */
-	pmap_tlb_asid_deactivate(pmap);
+#ifdef MULTIPROCESSOR
+	const uint32_t cpu_mask = 1 << cpu_index(curcpu());
+	KASSERT((pmap->pm_onproc & ~cpu_mask) == 0);
+	if (pmap->pm_onproc & cpu_mask)
+		pmap_tlb_asid_deactivate(pmap);
+#endif
 	pmap_tlb_asid_release_all(pmap);
 	pmap->pm_flags |= PMAP_DEFERRED_ACTIVATE;
+
+#ifdef PMAP_FAULTINFO
+	curpcb->pcb_faultinfo.pfi_faultaddr = 0;
+	curpcb->pcb_faultinfo.pfi_repeats = 0;
+	curpcb->pcb_faultinfo.pfi_faultpte = NULL;
+#endif
 	kpreempt_enable();
 }
@@ -1869,4 +1982,5 @@
 pmap_clear_reference(struct vm_page *pg)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 #ifdef DEBUG
 	if (pmapdebug & PDB_FOLLOW)
@@ -1874,5 +1988,5 @@
 		    VM_PAGE_TO_PHYS(pg));
 #endif
-	return pmap_clear_page_attributes(pg, PG_MD_REFERENCED);
+	return pmap_clear_mdpage_attributes(md, PG_MD_REFERENCED);
 }
 
@@ -1886,6 +2000,7 @@
 pmap_is_referenced(struct vm_page *pg)
 {
-
-	return PG_MD_REFERENCED_P(pg);
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+
+	return PG_MD_REFERENCED_P(md);
 }
 
@@ -1896,5 +2011,6 @@
 pmap_clear_modify(struct vm_page *pg)
 {
-	pv_entry_t pv = &pg->mdpage.pvh_first;
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+	pv_entry_t pv = &md->pvh_first;
 	pv_entry_t pv_next;
 	uint16_t gen;
@@ -1905,7 +2021,7 @@
 		printf("pmap_clear_modify(%#"PRIxPADDR")\n", VM_PAGE_TO_PHYS(pg));
 #endif
-	if (PG_MD_EXECPAGE_P(pg)) {
+	if (PG_MD_EXECPAGE_P(md)) {
 		if (pv->pv_pmap == NULL) {
-			pmap_clear_page_attributes(pg, PG_MD_EXECPAGE);
+			pmap_clear_mdpage_attributes(md, PG_MD_EXECPAGE);
 			PMAP_COUNT(exec_uncached_clear_modify);
 		} else {
@@ -1914,5 +2030,5 @@
 		}
 	}
-	if (!pmap_clear_page_attributes(pg, PG_MD_MODIFIED))
+	if (!pmap_clear_mdpage_attributes(md, PG_MD_MODIFIED))
 		return false;
 	if (pv->pv_pmap == NULL) {
@@ -1926,5 +2042,5 @@
 	 */
 	kpreempt_disable();
-	gen = VM_PAGE_PVLIST_LOCK(pg, false);
+	gen = PG_MD_PVLIST_LOCK(md, false);
 	for (; pv != NULL; pv = pv_next) {
 		pmap_t pmap = pv->pv_pmap;
@@ -1955,15 +2071,15 @@
 		}
 		pte->pt_entry = pt_entry;
-		VM_PAGE_PVLIST_UNLOCK(pg);
+		PG_MD_PVLIST_UNLOCK(md);
 		pmap_tlb_invalidate_addr(pmap, va);
 		pmap_update(pmap);
-		if (__predict_false(gen != VM_PAGE_PVLIST_LOCK(pg, false))) {
+		if (__predict_false(gen != PG_MD_PVLIST_LOCK(md, false))) {
 			/*
 			 * The list changed!  So restart from the beginning.
 			 */
-			pv_next = &pg->mdpage.pvh_first;
-		}
-	}
-	VM_PAGE_PVLIST_UNLOCK(pg);
+			pv_next = &md->pvh_first;
+		}
+	}
+	PG_MD_PVLIST_UNLOCK(md);
 	kpreempt_enable();
 	return true;
@@ -1979,6 +2095,7 @@
 pmap_is_modified(struct vm_page *pg)
 {
-
-	return PG_MD_MODIFIED_P(pg);
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+
+	return PG_MD_MODIFIED_P(md);
 }
 
@@ -1991,6 +2108,7 @@
 pmap_set_modified(paddr_t pa)
 {
-	struct vm_page *pg = PHYS_TO_VM_PAGE(pa);
-	pmap_set_page_attributes(pg, PG_MD_MODIFIED | PG_MD_REFERENCED);
+	struct vm_page * const pg = PHYS_TO_VM_PAGE(pa);
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+	pmap_set_mdpage_attributes(md, PG_MD_MODIFIED | PG_MD_REFERENCED);
 }
 
@@ -1998,8 +2116,8 @@
 
 static void
-pmap_check_pvlist(struct vm_page *pg)
+pmap_check_pvlist(struct vm_page_md *md)
 {
 #ifdef PARANOIADIAG
-	pt_entry_t pv = &pg->mdpage.pvh_first;
+	pt_entry_t pv = &md->pvh_first;
 	if (pv->pv_pmap != NULL) {
 		for (; pv != NULL; pv = pv->pv_next) {
@@ -2010,5 +2128,5 @@
 #endif
 		}
-		pv = &pg->mdpage.pvh_first;
+		pv = &md->pvh_first;
 	}
 #endif /* PARANOIADIAG */
@@ -2022,4 +2140,5 @@
 pmap_enter_pv(pmap_t pmap, vaddr_t va, struct vm_page *pg, u_int *npte)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 	pv_entry_t pv, npv, apv;
 	int16_t gen;
@@ -2033,5 +2152,5 @@
 
 	apv = NULL;
-	pv = &pg->mdpage.pvh_first;
+	pv = &md->pvh_first;
 #ifdef DEBUG
 	if (pmapdebug & PDB_ENTER)
@@ -2039,6 +2158,6 @@
 		    pv, pv->pv_va, pv->pv_pmap, pv->pv_next);
 #endif
-	gen = VM_PAGE_PVLIST_LOCK(pg, true);
-	pmap_check_pvlist(pg);
+	gen = PG_MD_PVLIST_LOCK(md, true);
+	pmap_check_pvlist(md);
 #if defined(MIPS3_NO_PV_UNCACHED) || defined(MULTIPROCESSOR)
 again:
@@ -2051,10 +2170,10 @@
 #ifdef DEBUG
 		if (pmapdebug & PDB_PVENTRY)
-			printf("pmap_enter: first pv: pmap %p va %#"PRIxVADDR"\n",
+			printf("pmap_enter_pv: first pv: pmap %p va %#"PRIxVADDR"\n",
 			    pmap, va);
 #endif
 		PMAP_COUNT(primary_mappings);
 		PMAP_COUNT(mappings);
-		pmap_clear_page_attributes(pg, PG_MD_UNCACHED);
+		pmap_clear_mdpage_attributes(md, PG_MD_UNCACHED);
 		pv->pv_pmap = pmap;
 		pv->pv_va = va;
@@ -2086,5 +2205,5 @@
 			}
 #else	/* !MIPS3_NO_PV_UNCACHED */
-			if (PG_MD_CACHED_P(pg)) {
+			if (PG_MD_CACHED_P(md)) {
 				/*
 				 * If this page is cached, then all mappings
@@ -2143,10 +2262,10 @@
 				    VM_PAGE_TO_PHYS(pg))
 					printf(
-		"pmap_enter: found va %#"PRIxVADDR" pa %#"PRIxPADDR" in pv_table but != %x\n",
+		"pmap_enter_pv: found va %#"PRIxVADDR" pa %#"PRIxPADDR" in pv_table but != %x\n",
 					    va, VM_PAGE_TO_PHYS(pg),
 					    pt_entry);
 #endif
 				PMAP_COUNT(remappings);
-				VM_PAGE_PVLIST_UNLOCK(pg);
+				PG_MD_PVLIST_UNLOCK(md);
 				if (__predict_false(apv != NULL))
 					pmap_pv_free(apv);
@@ -2156,19 +2275,20 @@
 #ifdef DEBUG
 		if (pmapdebug & PDB_PVENTRY)
-			printf("pmap_enter: new pv: pmap %p va %#"PRIxVADDR"\n",
+			printf("pmap_enter_pv: new pv: pmap %p va %#"PRIxVADDR"\n",
 			    pmap, va);
 #endif
 		if (__predict_true(apv == NULL)) {
-#ifdef MULTIPROCESSOR
+#if defined(MULTIPROCESSOR) || !defined(_LP64) || defined(PMAP_POOLPAGE_DEBUG) || defined(LOCKDEBUG)
 			/*
 			 * To allocate a PV, we have to release the PVLIST lock
 			 * so get the page generation.  We allocate the PV, and
-			 * then reacquire the lock.  
+			 * then reacquire the lock.
 			 */
-			VM_PAGE_PVLIST_UNLOCK(pg);
+			PG_MD_PVLIST_UNLOCK(md);
 #endif
 			apv = (pv_entry_t)pmap_pv_alloc();
 			if (apv == NULL)
 				panic("pmap_enter_pv: pmap_pv_alloc() failed");
+#if defined(MULTIPROCESSOR) || !defined(_LP64) || defined(PMAP_POOLPAGE_DEBUG) || defined(LOCKDEBUG)
 #ifdef MULTIPROCESSOR
 			/*
@@ -2178,7 +2298,10 @@
 			 */
 			uint16_t oldgen = gen;
-			gen = VM_PAGE_PVLIST_LOCK(pg, true);
+#endif
+			gen = PG_MD_PVLIST_LOCK(md, true);
+#ifdef MULTIPROCESSOR
 			if (gen != oldgen)
 				goto again;
+#endif
 #endif
 		}
@@ -2191,6 +2314,6 @@
 		PMAP_COUNT(mappings);
 	}
-	pmap_check_pvlist(pg);
-	VM_PAGE_PVLIST_UNLOCK(pg);
+	pmap_check_pvlist(md);
+	PG_MD_PVLIST_UNLOCK(md);
 	if (__predict_false(apv != NULL))
 		pmap_pv_free(apv);
@@ -2207,4 +2330,5 @@
 pmap_remove_pv(pmap_t pmap, vaddr_t va, struct vm_page *pg, bool dirty)
 {
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
 	pv_entry_t pv, npv;
 	bool last;
@@ -2216,8 +2340,8 @@
 #endif
 	KASSERT(kpreempt_disabled());
-	pv = &pg->mdpage.pvh_first;
-
-	(void)VM_PAGE_PVLIST_LOCK(pg, true);
-	pmap_check_pvlist(pg);
+	pv = &md->pvh_first;
+
+	(void)PG_MD_PVLIST_LOCK(md, true);
+	pmap_check_pvlist(md);
 
 	/*
@@ -2235,5 +2359,5 @@
 			KASSERT(pv->pv_pmap != NULL);
 		} else {
-			pmap_clear_page_attributes(pg, PG_MD_UNCACHED);
+			pmap_clear_mdpage_attributes(md, PG_MD_UNCACHED);
 			pv->pv_pmap = NULL;
 			last = true;	/* Last mapping removed */
@@ -2252,10 +2376,10 @@
 #ifdef MIPS3_PLUS	/* XXX mmu XXX */
 #ifndef MIPS3_NO_PV_UNCACHED
-	if (MIPS_HAS_R4K_MMU && PG_MD_UNCACHED_P(pg)) {
+	if (MIPS_HAS_R4K_MMU && PG_MD_UNCACHED_P(md)) {
 		/*
 		 * Page is currently uncached, check if alias mapping has been
 		 * removed.  If it was, then reenable caching.
 		 */
-		pv = &pg->mdpage.pvh_first;
+		pv = &md->pvh_first;
 		for (pv_entry_t pv0 = pv->pv_next; pv0; pv0 = pv0->pv_next) {
 			if (mips_cache_badalias(pv->pv_va, pv0->pv_va))
@@ -2267,6 +2391,6 @@
 #endif
 
-	pmap_check_pvlist(pg);
-	VM_PAGE_PVLIST_UNLOCK(pg);
+	pmap_check_pvlist(md);
+	PG_MD_PVLIST_UNLOCK(md);
 
 	/*
@@ -2275,5 +2399,5 @@
 	if (npv)
 		pmap_pv_free(npv);
-	if (PG_MD_EXECPAGE_P(pg) && dirty) {
+	if (PG_MD_EXECPAGE_P(md) && dirty) {
 		if (last) {
 			/*
@@ -2281,5 +2405,5 @@
 			 * care about its execness.
 			 */
-			pmap_clear_page_attributes(pg, PG_MD_EXECPAGE);
+			pmap_clear_mdpage_attributes(md, PG_MD_EXECPAGE);
 			PMAP_COUNT(exec_uncached_remove);
 		} else {
@@ -2329,8 +2453,8 @@
 
 uint16_t
-pmap_pvlist_lock(struct vm_page *pg, bool list_change)
+pmap_pvlist_lock(struct vm_page_md *md, bool list_change)
 {
 	struct pmap_pvlist_info * const pli = &pmap_pvlist_info;
-	kmutex_t *lock = pg->mdpage.pvh_lock;
+	kmutex_t *lock = md->pvh_lock;
 	int16_t gen;
 
@@ -2347,5 +2471,5 @@
 		 * the one they assigned.
 		 */
-		lock = atomic_cas_ptr(&pg->mdpage.pvh_lock, NULL, new_lock);
+		lock = atomic_cas_ptr(&md->pvh_lock, NULL, new_lock);
 		if (lock == NULL) {
 			lock = new_lock;
@@ -2363,7 +2487,7 @@
 	 * of attrs so we use that as a generation number.
 	 */
-	gen = VM_PAGE_PVLIST_GEN(pg);		/* get old value */
+	gen = PG_MD_PVLIST_GEN(md);		/* get old value */
 	if (list_change)
-		atomic_add_int(&pg->mdpage.pvh_attrs, 0x10000);
+		atomic_add_int(&md->pvh_attrs, 0x10000);
 
 	/*
@@ -2388,5 +2512,5 @@
 pmap_pv_page_alloc(struct pool *pp, int flags)
 {
-	struct vm_page *pg = PMAP_ALLOC_POOLPAGE(UVM_PGA_USERESERVE);
+	struct vm_page * const pg = PMAP_ALLOC_POOLPAGE(UVM_PGA_USERESERVE);
 	if (pg == NULL)
 		return NULL;
@@ -2417,6 +2541,7 @@
 		mips_dcache_inv_range(va, PAGE_SIZE);
 #endif
-	struct vm_page *pg = PHYS_TO_VM_PAGE(pa);
-	pmap_clear_page_attributes(pg, PG_MD_POOLPAGE);
+	struct vm_page * const pg = PHYS_TO_VM_PAGE(pa);
+	KASSERT(pg != NULL);
+	pmap_clear_mdpage_attributes(VM_PAGE_TO_MD(pg), PG_MD_POOLPAGE);
 	uvm_pagefree(pg);
 }
@@ -2490,7 +2615,8 @@
 	vaddr_t va;
 
-	struct vm_page *pg = PHYS_TO_VM_PAGE(pa);
+	struct vm_page * const pg = PHYS_TO_VM_PAGE(pa);
 	KASSERT(pg);
-	pmap_set_page_attributes(pg, PG_MD_POOLPAGE);
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);
+	pmap_set_mdpage_attributes(md, PG_MD_POOLPAGE);
 
 #ifdef PMAP_POOLPAGE_DEBUG
@@ -2536,12 +2662,12 @@
 		 * cause aliases, flush the page from the cache.
 		 */
-		(void)VM_PAGE_PVLIST_LOCK(pg, false);
-		pv_entry_t pv = &pg->mdpage.pvh_first;
+		(void)PG_MD_PVLIST_LOCK(md, false);
+		pv_entry_t pv = &md->pvh_first;
 		vaddr_t last_va = pv->pv_va;
 		KASSERT(pv->pv_pmap == NULL);
 		pv->pv_va = va;
-		if (PG_MD_CACHED_P(pg) && mips_cache_badalias(last_va, va))
-			mips_dcache_wbinv_range_index(last_va, PAGE_SIZE); 
-		VM_PAGE_PVLIST_UNLOCK(pg);
+		if (PG_MD_CACHED_P(md) && mips_cache_badalias(last_va, va))
+			mips_dcache_wbinv_range_index(last_va, PAGE_SIZE);
+		PG_MD_PVLIST_UNLOCK(md);
 	}
 #endif
@@ -2554,5 +2680,5 @@
 	paddr_t pa;
 #ifdef PMAP_POOLPAGE_DEBUG
-	KASSERT(poolpage.start <= va && va < poolpage.start + poolpage.size);
+	KASSERT(poolpage.base <= va && va < poolpage.base + poolpage.size);
 	pa = mips_tlbpfn_to_paddr(kvtopte(va)->pt_entry);
 #elif defined(_LP64)
@@ -2565,5 +2691,5 @@
 	struct vm_page *pg = PHYS_TO_VM_PAGE(pa);
 	KASSERT(pg);
-	pmap_clear_page_attributes(pg, PG_MD_POOLPAGE);
+	pmap_clear_mdpage_attributes(VM_PAGE_TO_MD(pg), PG_MD_POOLPAGE);
 #if defined(MIPS3_PLUS)
 	if (MIPS_CACHE_VIRTUAL_ALIAS) {
